--[[
##########################################################
PsychoUI!: keivamp
##########################################################
]]--
--local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local addon, ns = ...
local addonName, addon = ...
local cfg = CreateFrame("Frame")
local F, G, V = unpack(select(2, ...))
--ActionBars config
	local ButtonSize = 35
	local ButtonSpacing = 3
	local ButtonSize_small = 30
	local ButtonSpacing_small = 3
	function UpdateCFG()

		ButtonSize = 35

	end
	-- local UpdateCFGFrame = CreateFrame("Frame")	
	-- UpdateCFGFrame:HookScript("OnUpdate",UpdateCFG)
 


cfg.bars = {
	["Bar1"] = {
		hide_bar = true,
		show_in_combat = false,
		show_on_mouseover = true,
		bar_alpha = 1,
		fadeout_alpha = 0.5,
		orientation = "HORIZONTAL",
		rows = 1,
		buttons = 12,
		button_size = ButtonSize,
		button_spacing = ButtonSpacing,
		position = { a = "BOTTOM", x = 0, y = 15 },
		custom_visibility_macro = "[petbattle][overridebar][vehicleui][possessbar,@vehicle,exists]hide;show" -- set a custom visibility macro for this bar or 'false' to disable
		-- (e.g. "[petbattle][overridebar][vehicleui][possessbar,@vehicle,exists]hide;show")
	},
	--bottomleft
	["Bar2"] = {
		hide_bar = false,
		show_in_combat = false,
		show_on_mouseover = false,
		bar_alpha = 1,
		fadeout_alpha = 0.5,
		orientation = "HORIZONTAL",
		rows = 2,
		buttons = 12,
		button_size = ButtonSize,
		button_spacing = ButtonSpacing,
		position = { a = "BOTTOM", x = -(((ButtonSize*9)+(ButtonSpacing*9))+5), y = 15+(ButtonSize+ButtonSpacing) },
		custom_visibility_macro = false,
		--button:SetNormalTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		
	},
	--bottomright
	
	
	["Bar3"] = {
	
		hide_bar = false,
		show_in_combat = false,
		show_on_mouseover = false,
		bar_alpha = 1,
		fadeout_alpha = 0.5,
		orientation = "HORIZONTAL",
		rows = 2,
		buttons = 12,
		button_size = ButtonSize,
		button_spacing = ButtonSpacing,
		position = { a = "BOTTOM", x = (((ButtonSize*9)+(ButtonSpacing*9))+5), y = 15+(ButtonSize+ButtonSpacing)  },
		custom_visibility_macro = false
	},
	--Right Action Bar
	["Bar4"] = {
		hide_bar = false,
		show_in_combat = false,
		show_on_mouseover = false,
		bar_alpha = 1,
		fadeout_alpha = 0.0,
		orientation = "VERTICAL",
		rows = 1,
		buttons = 12,
		button_size = ButtonSize,
		button_spacing = ButtonSpacing,
		position = { a = "RIGHT", x = -(ButtonSize+ButtonSpacing)*1.25, y = -80  },
		--position = { a = "RIGHT", x = -(ButtonSize+ButtonSpacing)*0.25, y = -80 },
		custom_visibility_macro = false
	},
	--Right Action Bar
	["Bar5"] = {
		hide_bar = false,
		show_in_combat = false,
		show_on_mouseover = false,
		bar_alpha = 1,
		fadeout_alpha = 0.0,
		orientation = "VERTICAL",
		rows = 1,
		buttons = 12,
		button_size = ButtonSize,
		button_spacing = ButtonSpacing,
		position = { a = "RIGHT", x = -(ButtonSize+ButtonSpacing)*1.25, y = -80  },
		position = { a = "RIGHT", x = -(ButtonSize+ButtonSpacing)*0.25, y = -80 },
		custom_visibility_macro = false
	},
	--Extra Action Bar--
	["Bar6"] = {
		hide_bar = false,
		show_in_combat = false,
		show_on_mouseover = false,
		bar_alpha = 1,
		fadeout_alpha = 0.5,
		orientation = "HORIZONTAL",
		rows = 1,
		buttons = 12,
		button_size = ButtonSize,
		button_spacing = ButtonSpacing,
		position = { a = "BOTTOM", x = 0, y = ((ButtonSize+ButtonSpacing)*1.25) +5},
		
		custom_visibility_macro = false
	},
	["StanceBar"] = {
		hide_bar = false,
		show_in_combat = false,
		show_on_mouseover = false,
		bar_alpha = 1,
		fadeout_alpha = 0.0,
		orientation = "HORIZONTAL",
		rows = 2,
		buttons = 6,
		button_size = 50,
		button_spacing = ButtonSpacing_small,
		position = { a = "BOTTOM", x = -110, y = (((ButtonSize+ButtonSpacing)*2.25)+5) },
		custom_visibility_macro = false
	},
	["PetBar"] = {
		hide_bar = false,
		show_in_combat = false,
		scale = 0.8,
		show_on_mouseover = false,
		bar_alpha = 1,
		fadeout_alpha = 0.0,
		orientation = "HORIZONTAL",
		rows = 1,
		buttons = 10,
		button_size = ButtonSize_small,
		button_spacing = ButtonSpacing_small,
		position = { a = "BOTTOM", x = 0, y = (((ButtonSize+ButtonSpacing)*2.25)+5)  },
		custom_visibility_macro = false
	},
	--[[
	["MicroMenu"] = {
		hide_bar = true,
		show_on_mouseover = false,
		scale = 1,
		lock_to_CharacterFrame = false, -- position MicroMenu bar right on top of your CharacterFrame
		position = { a = "TOPLEFT", x = 10, y = -10 }, -- if not locked
	},
	]]--
	["ExtraButton"] = {
		disable = false,
		position = { a = "BOTTOM", x = 0, y = 400 },
	},
	["RaidIconBar"] = {
		hide = false,
		in_group_only = false,
		show_on_mouseover = false,
		bar_alpha = 1,
		fadeout_alpha = 0.5,
		orientation = "VERTICAL",
		rows = 1,
		button_size = 20,
		button_spacing = 3,
		position = { a = "RIGHT", x = -10, y = -77 },
	},
	["WorldMarkerBar"] = {
		hide = false,
		disable_in_combat = true,
		show_on_mouseover = false,
		bar_alpha = 1,
		fadeout_alpha = 0.5,
		orientation = "VERTICAL",
		rows = 1,
		button_size = 20,
		button_spacing = ButtonSpacing,
		position = { a = "RIGHT", x = -10, y = 122 },
	},
	["ExitVehicleButton"] = {
		position = { a = "RIGHT", x = 0, y = 0 },
	},
}


	
	
	


-- HANDOVER
ns.cfg = cfg

StanceBarFrame:SetScale(1)

-------------------------- CONFIG END ----------------------------------------


local cfg = ns.cfg
--local PsychoUI = LibStub("AceAddon-3.0"):GetAddon("PsychoUI")
local mAB = CreateFrame("Frame")



-- holder creating func
mAB.CreateHolder = function(name, pos)
	local bar = CreateFrame("Frame", name, UIParent, "SecureHandlerStateTemplate")
	bar:SetPoint(pos.a, pos.x, pos.y)
	bar:SetFrameStrata("MEDIUM")
	return bar
end

-- I always wanted to have my personal death star to destroy stuff!
local DeathStar = mAB.CreateHolder("DeathStar", { a = "TOP", x = 0, y = 100 })
DeathStar:Hide()

-- style function for bars
--mAB.SetBar = function(bar, btn, num, orient, rows, visnum, bsize, spacing)
mAB.SetBar = function(bar, btn, num, cfgn)
 ButtonSize = 35
 
	local orient, rows, visnum, bsize, spacing = cfg.bars[cfgn].orientation, cfg.bars[cfgn].rows, cfg.bars[cfgn].buttons, ButtonSize, ButtonSpacing
	
	local pad = spacing or cfg.spacing
	local first_row_num = math.floor(visnum / rows)
	local buttonList = {}
	for i = 1, 12 do
		local button = _G[btn .. i]
		if not button then
			break
		end
		table.insert(buttonList, button) --add the button object to the list
		button:SetSize(bsize, bsize)
		button:ClearAllPoints()
		--button.NormalTexture:SetTexture("Interface\\Addons\\PsychoUI\\Textures\\Action Bars\\RogueBTN")
		--button.NormalTexture:SetAllPoints()
		if i == 1 then
			button:SetPoint("BOTTOMLEFT", bar, 0, 0)
		else
			local previous = _G[btn .. i - 1]

			if orient == "HORIZONTAL" then
				if rows == 1 then
					button:SetPoint("LEFT", previous, "RIGHT", spacing, 0)
				else
					button:SetPoint("TOPLEFT", previous, "TOPRIGHT", pad, 0)
					if i == first_row_num + 1 then
						button:SetPoint("TOPLEFT", _G[btn .. (i - first_row_num)], "BOTTOMLEFT", 0, -pad)
						
					end
					if i == first_row_num * 2 + 1 then
						button:SetPoint("TOPLEFT", _G[btn .. (i - first_row_num)], "BOTTOMLEFT", 0, -pad)
					end
				end
			else
				if rows == 1 then
					button:SetPoint("BOTTOMLEFT", previous, "TOPLEFT", 0, pad)
				else
					button:SetPoint("BOTTOMLEFT", previous, "TOPLEFT", 0, pad)
					if i == first_row_num + 1 then
						button:SetPoint("BOTTOMLEFT", _G[btn .. (i - first_row_num)], "BOTTOMRIGHT", pad, 0)
					end
					if i == first_row_num * 2 + 1 then
						button:SetPoint("BOTTOMLEFT", _G[btn .. (i - first_row_num)], "BOTTOMRIGHT", pad, 0)
					end
				end
			end
			if i > visnum then
				button:SetParent(DeathStar)
			end
		end
	end
	if orient == "HORIZONTAL" then
		if rows == 1 then
			bar:SetWidth(bsize * visnum + pad * (visnum - 1))
			bar:SetHeight(bsize)
		else
			bar:SetWidth(bsize * first_row_num + pad * (first_row_num - 1))
			bar:SetHeight(bsize * rows + pad)
		end
	else
		if rows == 1 then
			bar:SetWidth(bsize)
			bar:SetHeight(bsize * visnum + pad * (visnum - 1))
		else
			bar:SetWidth(bsize * rows + pad)
			bar:SetHeight(bsize * first_row_num + pad * (first_row_num - 1))
		end
	end
end

-- modified styling function for Extra Action Bar
mAB.SetExtraBar = function(bar, bname, orient, rows, visnum, bsize, spacing)

	local pad = spacing or cfg.spacing
	local first_row_num = math.floor(visnum / rows)
	for i = 13, 24 do
		local btn = CreateFrame("CheckButton", bname .. (i - 12), UIParent, "ActionBarButtonTemplate")
		btn:SetAttribute("action", i)
		btn:SetID(i)

		btn:SetAttribute("showgrid", 1)
		btn:SetAttribute("statehidden", nil)
		btn:ClearAllPoints()
		btn:SetSize(bsize, bsize)
		btn:SetParent(bar)
		if i == 13 then
			btn:SetPoint("TOPLEFT", bar, "TOPLEFT", 0, 0)
		else
			if orient == "HORIZONTAL" then
				if rows == 1 then
					btn:SetPoint("TOPLEFT", _G[bname .. (i - 13)], "TOPRIGHT", pad, 0)
				else
					btn:SetPoint("TOPLEFT", _G[bname .. (i - 13)], "TOPRIGHT", pad, 0)
					if i == 12 + first_row_num + 1 then
						btn:SetPoint("TOPLEFT", _G[bname .. (i - first_row_num - 12)], "BOTTOMLEFT", 0, -pad)
					end
					if i == 12 + first_row_num * 2 + 1 then
						btn:SetPoint("TOPLEFT", _G[bname .. (i - first_row_num - 12)], "BOTTOMLEFT", 0, -pad)
					end
				end
			else
				if rows == 1 then
					btn:SetPoint("TOPLEFT", _G[bname .. (i - 13)], "BOTTOMLEFT", 0, -pad)
				else
					btn:SetPoint("TOPLEFT", _G[bname .. (i - 13)], "BOTTOMLEFT", 0, -pad)
					if i == 12 + first_row_num + 1 then
						btn:SetPoint("TOPLEFT", _G[bname .. (i - first_row_num - 12)], "TOPRIGHT", pad, 0)
					end
					if i == 12 + first_row_num * 2 + 1 then
						btn:SetPoint("TOPLEFT", _G[bname .. (i - first_row_num - 12)], "TOPRIGHT", pad, 0)
					end
				end
			end
			if i > visnum + 12 then
				btn:SetParent(DeathStar)
			end
		end
	end
	if orient == "HORIZONTAL" then
		if rows == 1 then
			bar:SetWidth(bsize * visnum + pad * (visnum - 1))
			bar:SetHeight(bsize)
		else
			bar:SetWidth(bsize * first_row_num + pad * (first_row_num - 1))
			bar:SetHeight(bsize * rows + pad)
		end
	else
		if rows == 1 then
			bar:SetWidth(bsize)
			bar:SetHeight(bsize * visnum + pad * (visnum - 1))
		else
			bar:SetWidth(bsize * rows + pad)
			bar:SetHeight(bsize * first_row_num + pad * (first_row_num - 1))
		end
	end
end

-- mouseover visibility condition
mAB.SetBarAlpha = function(bar, button, num, cfgn)
	local switch, baralpha, fadealpha = cfg.bars[cfgn].show_on_mouseover, cfg.bars[cfgn].bar_alpha, cfg.bars[cfgn].fadeout_alpha
	if switch then
		local function lighton(alpha)
			if bar and bar:IsShown() then
				for i = 1, num do
					local pb = _G[button .. i]
					pb:SetAlpha(alpha)
				end
			end
		end

		bar:EnableMouse(true)
		bar:SetScript("OnEnter", function(self) lighton(1) end)
		bar:SetScript("OnLeave", function(self) lighton(fadealpha or 0) end)
		for i = 1, num do
			local pb = _G[button .. i]
			pb:SetAlpha(fadealpha or 0)
			pb:HookScript("OnEnter", function(self) lighton(1) end)
			pb:HookScript("OnLeave", function(self) lighton(fadealpha or 0) end)
		end
	end
	bar:SetAlpha(baralpha or 1)
end

-- visibility condition
mAB.SetVisibility = function(n, bar)
	local ncfg = cfg.bars[n]
	if ncfg.hide_bar then
		bar:Hide()
	elseif ncfg.custom_visibility_macro then
		RegisterStateDriver(bar, "visibility", ncfg.custom_visibility_macro)
		return
	elseif ncfg.show_in_combat then
		if n == "Bar1" then
	
			RegisterStateDriver(bar, "visibility", "[petbattle][overridebar][vehicleui][possessbar,@vehicle,exists]hide;[combat,novehicleui] show;hide")
			--RegisterStateDriver(bar, "visibility", "[petbattle][overridebar][vehicleui][possessbar,@vehicle,exists]hide; show")
		else
			RegisterStateDriver(bar, "visibility", "[petbattle]hide;[combat] show; hide")
		end
	else
		if n == "Bar1" then
		
			RegisterStateDriver(bar, "visibility", "[petbattle][overridebar][vehicleui][possessbar,@vehicle,exists]hide;show")
		else
			RegisterStateDriver(bar, "visibility", "[petbattle]hide;show")
		end
	end
end

mAB.SetStanceBar = function(bar, btn, num)

	local orient, rows, visnum, bsize, spacing = cfg.bars["StanceBar"].orientation, cfg.bars["StanceBar"].rows, cfg.bars["StanceBar"].buttons, ButtonSize, ButtonSpacing
	local buttonList = {}
	local pad = spacing or cfg.spacing
	if orient == "HORIZONTAL" then
		bar:SetWidth(bsize * visnum + pad * (visnum ))
		bar:SetHeight(bsize)
	else
		bar:SetWidth(bsize)
		bar:SetHeight(bsize * visnum + pad * (visnum ))
	end

	for i = 1, 6 do

		local button = _G[btn .. i]
		table.insert(buttonList, button) --add the button object to the list
		--button:SetSize(32, 32)
		--button:ClearAllPoints()


		if orient == "HORIZONTAL" then
			if i == 1 then
			--	button:SetPoint("BOTTOMLEFT", bar, 0, 0)
			else
				local previous = _G[btn .. i - 1]
				--button:SetPoint("LEFT", previous, "RIGHT", spacing, 0)
			end
		else
			if i == 1 then
				--button:SetPoint("BOTTOMLEFT", bar, spacing, spacing)
			--	button:SetPoint("TOPLEFT", bar, "TOPLEFT", 0, 0)
			else
				local previous = _G[btn .. i - 1]
				--button:SetPoint("LEFT", previous, "RIGHT", spacing, 0)
			--	button:SetPoint("TOPLEFT", _G[btn .. (i - 1)], "BOTTOMLEFT", 0, -pad)
			end
		end
	end
end

ns.mAB = mAB


-------------------------------------------------------------- LIB END ----------------------------


local cfg = ns.cfg
local mAB = ns.mAB

-- myclass = select(2, UnitClass("player"))

--if not cfg.enable_action_bars then return end
--if IsAddOnLoaded("Dominos") then return end



-- enabling default action bars
local f = CreateFrame "Frame"
f:RegisterEvent("PLAYER_ENTERING_WORLD")
--f:RegisterEvent("VARIABLES_LOADED")
f:SetScript("OnEvent", function()
 --if PsychoUI.db.char.UseActionBars == false then return end
	if InCombatLockdown() then return end
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		
		local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
		ButtonSize = 35
	-- show grid
	for i = 1, 12 do
	
		local btn = _G[format("ActionButton%d", i)]
		btn:SetAttribute("showgrid", 1)
		btn:SetAttribute("statehidden", false)
		btn:SetWidth(ButtonSize) -- Set these to whatever height/width is needed 
		btn:SetHeight(ButtonSize)
		btn.NormalTexture:SetTexture(ThisTexture)
		
		btn.NormalTexture:SetAllPoints()
		btn:SetHighlightTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex")
		btn:SetPushedTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex")
		btn:Show()
		btn:SetAlpha(1)

		--ActionButton_ShowGrid(btn)
	
		btn = _G[format("MultiBarRightButton%d", i)]
		btn:SetAttribute("showgrid", 1)
		btn:SetAttribute("statehidden", false)
		btn:SetWidth(ButtonSize) -- Set these to whatever height/width is needed 
		btn:SetHeight(ButtonSize)
		btn.NormalTexture:SetTexture(ThisTexture)
		 btn.NormalTexture:SetAllPoints()
		btn:SetHighlightTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex")
		btn:SetPushedTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex")
		btn:Show()
		btn:SetAlpha(1)
		--ActionButton_ShowGrid(btn)

		btn = _G[format("MultiBarBottomRightButton%d", i)]
		btn:SetAttribute("showgrid", 1)
		btn:SetAttribute("statehidden", false)
		btn:SetWidth(ButtonSize) -- Set these to whatever height/width is needed 
		btn:SetHeight(ButtonSize)
		 btn.NormalTexture:SetTexture(ThisTexture)
		 btn.NormalTexture:SetAllPoints()
		btn:SetHighlightTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex")
		btn:SetPushedTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex")
		btn:Show()
		btn:SetAlpha(1)
		--ActionButton_ShowGrid(btn)

		btn = _G[format("MultiBarLeftButton%d", i)]
		btn:SetAttribute("showgrid", 1)
		btn:SetAttribute("statehidden", false)
		btn:SetWidth(ButtonSize) -- Set these to whatever height/width is needed 
		btn:SetHeight(ButtonSize)
		 btn.NormalTexture:SetTexture(ThisTexture)
		 btn.NormalTexture:SetAllPoints()
		btn:SetHighlightTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex")
		btn:SetPushedTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex")
		btn:Show()
		btn:SetAlpha(1)
		--ActionButton_ShowGrid(btn)

		btn = _G[format("MultiBarBottomLeftButton%d", i)]
		btn:SetAttribute("showgrid", 1)
		btn:SetAttribute("statehidden", false)
		btn:SetWidth(ButtonSize) -- Set these to whatever height/width is needed 
		btn:SetHeight(ButtonSize)
		btn.NormalTexture:SetTexture(ThisTexture)
		 btn.NormalTexture:SetAllPoints()
		btn:SetHighlightTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex")
		btn:SetPushedTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex")
		btn:Show()
		btn:SetAlpha(1)
		--ActionButton_ShowGrid(btn)

		btn = _G[format("ExtraBarButton%d", i)]
		btn:SetAttribute("showgrid", 1)
		btn:SetAttribute("statehidden", false)
		btn:SetWidth(ButtonSize) -- Set these to whatever height/width is needed 
		btn:SetHeight(ButtonSize)
		btn.NormalTexture:SetTexture(ThisTexture)
		 btn.NormalTexture:SetAllPoints()
		btn:SetHighlightTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex")
		btn:SetPushedTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex")
		btn:Show()
		--btn:SetAlpha(1)
		
		btn = _G[format("PetActionButton%d", i)]

	end
		-- StanceButton1:CreateBeautyBorder(6)
		-- StanceButton1:SetBeautyBorderPadding(1)
		-- StanceButton1:SetBeautyBorderTexture("white")
		-- StanceButton1:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- StanceButton2:CreateBeautyBorder(6)
		-- StanceButton2:SetBeautyBorderPadding(1)
		-- StanceButton2:SetBeautyBorderTexture("white")
		-- StanceButton2:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- StanceButton3:CreateBeautyBorder(6)
		-- StanceButton3:SetBeautyBorderPadding(1)
		-- StanceButton3:SetBeautyBorderTexture("white")
		-- StanceButton3:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- StanceButton4:CreateBeautyBorder(6)
		-- StanceButton4:SetBeautyBorderPadding(1)
		-- StanceButton4:SetBeautyBorderTexture("white")
		-- StanceButton4:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- StanceButton5:CreateBeautyBorder(6)
		-- StanceButton5:SetBeautyBorderPadding(1)
		-- StanceButton5:SetBeautyBorderTexture("white")
		-- StanceButton5:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- StanceButton6:CreateBeautyBorder(6)
		-- StanceButton6:SetBeautyBorderPadding(1)
		-- StanceButton6:SetBeautyBorderTexture("white")
		-- StanceButton6:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- StanceButton7:CreateBeautyBorder(6)
		-- StanceButton7:SetBeautyBorderPadding(1)
		-- StanceButton7:SetBeautyBorderTexture("white")
		-- StanceButton7:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- StanceButton8:CreateBeautyBorder(6)
		-- StanceButton8:SetBeautyBorderPadding(1)
		-- StanceButton8:SetBeautyBorderTexture("white")
		-- StanceButton8:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- PetActionButton1:CreateBeautyBorder(6)
		-- PetActionButton1:SetBeautyBorderPadding(1)
		-- PetActionButton1:SetBeautyBorderTexture("white")
		-- PetActionButton1:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- PetActionButton2:CreateBeautyBorder(6)
		-- PetActionButton2:SetBeautyBorderPadding(1)
		-- PetActionButton2:SetBeautyBorderTexture("white")
		-- PetActionButton2:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- PetActionButton3:CreateBeautyBorder(6)
		-- PetActionButton3:SetBeautyBorderPadding(1)
		-- PetActionButton3:SetBeautyBorderTexture("white")
		-- PetActionButton3:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- PetActionButton4:CreateBeautyBorder(6)
		-- PetActionButton4:SetBeautyBorderPadding(1)
		-- PetActionButton4:SetBeautyBorderTexture("white")
		-- PetActionButton4:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- PetActionButton5:CreateBeautyBorder(6)
		-- PetActionButton5:SetBeautyBorderPadding(1)
		-- PetActionButton5:SetBeautyBorderTexture("white")
		-- PetActionButton5:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- PetActionButton6:CreateBeautyBorder(6)
		-- PetActionButton6:SetBeautyBorderPadding(1)
		-- PetActionButton6:SetBeautyBorderTexture("white")
		-- PetActionButton6:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- PetActionButton7:CreateBeautyBorder(6)
		-- PetActionButton7:SetBeautyBorderPadding(1)
		-- PetActionButton7:SetBeautyBorderTexture("white")
		-- PetActionButton7:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- PetActionButton8:CreateBeautyBorder(6)
		-- PetActionButton8:SetBeautyBorderPadding(1)
		-- PetActionButton8:SetBeautyBorderTexture("white")
		-- PetActionButton8:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		
		-- PetActionButton9:CreateBeautyBorder(6)
		-- PetActionButton9:SetBeautyBorderPadding(1)
		-- PetActionButton9:SetBeautyBorderTexture("white")
		-- PetActionButton9:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
		
		-- PetActionButton10:CreateBeautyBorder(6)
		-- PetActionButton10:SetBeautyBorderPadding(1)
		-- PetActionButton10:SetBeautyBorderTexture("white")
		-- PetActionButton10:SetBeautyBorderColor(playerColor.r, playerColor.g, playerColor.b)
end)

--- - Modifying default action bars
-- Creating holder frames for each bar
local mainbar = mAB.CreateHolder("Bar1_holder", cfg.bars["Bar1"].position)
local overridebar = mAB.CreateHolder("OverrideBar_holder", cfg.bars["Bar1"].position)
local bottomleftbar = mAB.CreateHolder("Bar2_holder", cfg.bars["Bar2"].position)
local bottomrightbar = mAB.CreateHolder("Bar3_holder", cfg.bars["Bar3"].position)
leftbar = mAB.CreateHolder("Bar4_holder", cfg.bars["Bar4"].position)
rightbar = mAB.CreateHolder("Bar5_holder", cfg.bars["Bar5"].position)
local extrabar = mAB.CreateHolder("Bar6_holder", cfg.bars["Bar6"].position)
local stancebar = mAB.CreateHolder("StanceBar_holder", cfg.bars["StanceBar"].position)
local petbar = mAB.CreateHolder("PetBar_holder", { a = cfg.bars["PetBar"].position.a, x = cfg.bars["PetBar"].position.x * 1.25, y = cfg.bars["PetBar"].position.y * 1.25 })
local exitVehicle = mAB.CreateHolder("ExitVehicle_holder", cfg.bars["ExitVehicleButton"].position)
--local extrabtn = mAB.CreateHolder("ExtraBtn_holder", cfg.ExtraButton["Position"])

--- - Forging action bars
-- parenting action buttons to our holders
--MainMenuBarArtFrame:SetParent(mainbar)
--OverrideActionBar:SetParent(overridebar)
--OverrideActionBar:EnableMouse(false)
--OverrideActionBar:SetScript("OnShow", nil)
MultiBarBottomLeft:SetParent(bottomleftbar)
MultiBarBottomRight:SetParent(bottomrightbar)
MultiBarLeft:SetParent(leftbar)
MultiBarRight:SetParent(rightbar)
MultiBarRight:EnableMouse(false)
PetActionBarFrame:SetParent(petbar)
--PossessBarFrame:SetParent(stancebar)
--PossessBarFrame:EnableMouse(false)
StanceBarFrame:SetParent(stancebar)
StanceBarFrame:SetPoint("BOTTOMLEFT", stancebar, -12, -3)
StanceBarFrame.ignoreFramePositionManager = true

-- set up action bars
mAB.SetBar(mainbar, "ActionButton", NUM_ACTIONBAR_BUTTONS, "Bar1")
mAB.SetBar(overridebar, "OverrideActionBarButton", NUM_ACTIONBAR_BUTTONS, "Bar1")
RegisterStateDriver(overridebar, "visibility", "[petbattle] hide; [overridebar][vehicleui][possessbar,@vehicle,exists] show; hide")
--RegisterStateDriver(OverrideActionBar, "visibility", "[overridebar][vehicleui][possessbar,@vehicle,exists] show; hide")
mAB.SetBar(bottomleftbar, "MultiBarBottomLeftButton", NUM_ACTIONBAR_BUTTONS, "Bar2")
mAB.SetBar(bottomrightbar, "MultiBarBottomRightButton", NUM_ACTIONBAR_BUTTONS, "Bar3")
mAB.SetBar(leftbar, "MultiBarLeftButton", NUM_ACTIONBAR_BUTTONS, "Bar4")
mAB.SetBar(rightbar, "MultiBarRightButton", NUM_ACTIONBAR_BUTTONS, "Bar5")
mAB.SetBar(petbar, "PetActionButton", NUM_PET_ACTION_SLOTS, "PetBar")
petbar:SetScale(cfg.bars["PetBar"].scale or 0.80)
RegisterStateDriver(petbar, "visibility", "[pet,novehicleui,nobonusbar:5] show; hide")
mAB.SetStanceBar(stancebar, "StanceButton", NUM_STANCE_SLOTS)
mAB.SetStanceBar(stancebar, "PossessButton", NUM_POSSESS_SLOTS)
mAB.SetExtraBar(extrabar, "ExtraBarButton", cfg.bars["Bar6"].orientation, cfg.bars["Bar6"].rows, cfg.bars["Bar6"].buttons, cfg.bars["Bar6"].button_size, cfg.bars["Bar6"].button_spacing)
-- due to new ActionBarController introduced in WoW 5.0 we have to update the extra bar independently and lock it to page 1
extrabar:RegisterEvent("PLAYER_LOGIN")
extrabar:SetScript("OnEvent", function(self, event, ...)
 --if PsychoUI.db.char.UseActionBars == false then return end
	for id = 1, NUM_ACTIONBAR_BUTTONS do
		local name = "ExtraBarButton" .. id
		self:SetFrameRef(name, _G[name])
	end
	self:Execute(([[
			buttons = table.new()
			for id = 1, %s do
				buttons[id] = self:GetFrameRef("ExtraBarButton"..id)
			end
		]]):format(NUM_ACTIONBAR_BUTTONS))
	self:SetAttribute('_onstate-page', ([[
			if not newstate then return end
			for id = 1, %s do
				buttons[id]:SetAttribute("actionpage", 1)
			end
		]]):format(NUM_ACTIONBAR_BUTTONS))
	RegisterStateDriver(self, "page", 1)
end)


local bars_visible = false

-- apply alpha and mouseover functionality
mAB.SetBarAlpha(mainbar, "ActionButton", NUM_ACTIONBAR_BUTTONS, "Bar1")
mAB.SetBarAlpha(bottomleftbar, "MultiBarBottomLeftButton", NUM_ACTIONBAR_BUTTONS, "Bar2")
mAB.SetBarAlpha(bottomrightbar, "MultiBarBottomRightButton", NUM_ACTIONBAR_BUTTONS, "Bar3")
mAB.SetBarAlpha(leftbar, "MultiBarLeftButton", NUM_ACTIONBAR_BUTTONS, "Bar4")
mAB.SetBarAlpha(rightbar, "MultiBarRightButton", NUM_ACTIONBAR_BUTTONS, "Bar5")
mAB.SetBarAlpha(extrabar, "ExtraBarButton", NUM_ACTIONBAR_BUTTONS, "Bar6")
mAB.SetBarAlpha(stancebar, "StanceButton", NUM_STANCE_SLOTS, "StanceBar")
mAB.SetBarAlpha(petbar, "PetActionButton", NUM_PET_ACTION_SLOTS, "PetBar")

-- apply visibility conditions
mAB.SetVisibility("Bar1", mainbar)
mAB.SetVisibility("Bar2", bottomleftbar)
mAB.SetVisibility("Bar3", bottomrightbar)
mAB.SetVisibility("Bar4", leftbar)
mAB.SetVisibility("Bar5", rightbar)
mAB.SetVisibility("Bar6", extrabar)
mAB.SetVisibility("StanceBar", stancebar)
mAB.SetVisibility("PetBar", petbar)


-- hiding default frames and textures

local OverrideTexList = {
	"_BG",
	"_MicroBGMid",
	"_Border",
	"EndCapL",
	"EndCapR",
	"Divider1",
	"Divider2",
	"Divider3",
	"ExitBG",
	"MicroBGL",
	"MicroBGR",
	"ButtonBGL",
	"ButtonBGR",
	"_ButtonBGMid",
}


